# Interface PrivateKey

All Superinterfaces:
  `AsymmetricKey, DEREncodablePREVIEW, Destroyable, Key, Serializable`

All Known Subinterfaces:
  `DHPrivateKey, DSAPrivateKey, ECPrivateKey, EdECPrivateKey, RSAMultiPrimePrivateCrtKey, RSAPrivateCrtKey, RSAPrivateKey, XECPrivateKey`

public interface PrivateKey extends AsymmetricKey, Destroyable
A private key. The purpose of this interface is to group (and provide type safety for) all private key interfaces.

Note: The specialized private key interfaces extend this interface. See, for example, the `DSAPrivateKey` interface in `java.security.interfaces`.

Implementations should override the default `destroy` and `isDestroyed` methods from the `Destroyable` interface to enable sensitive key information to be destroyed, cleared, or in the case where such information is immutable, unreferenced. Finally, since `PrivateKey` is `Serializable`, implementations should also override `ObjectOutputStream.writeObject(java.lang.Object)` to prevent keys that have been destroyed from being serialized.

Since:
  1.1
See Also:
  - `Key`
  - `PublicKey`
  - `Certificate`
  - `Signature.initVerify(PublicKey)`
  - `DSAPrivateKey`
  - `RSAPrivateKey`
  - `RSAPrivateCrtKey`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final long`
  `serialVersionUID`
  Deprecated.
  A `serialVersionUID` field in an interface is ineffectual.

- ## Method Summary

  ### Methods declared in interface AsymmetricKey

  `getParams`
  Modifier and Type
  Method
  Description
  `default AlgorithmParameterSpec`
  `getParams()`
  Returns the parameters associated with this key.

  ### Methods declared in interface Destroyable

  `destroy, isDestroyed`
  Modifier and Type
  Method
  Description
  `default void`
  `destroy()`
  Destroy this `Object`.
  `default boolean`
  `isDestroyed()`
  Determine if this `Object` has been destroyed.

  ### Methods declared in interface Key

  `getAlgorithm, getEncoded, getFormat`
  Modifier and Type
  Method
  Description
  `String`
  `getAlgorithm()`
  Returns the standard algorithm name for this key.
  `byte[]`
  `getEncoded()`
  Returns the key in its primary encoding format, or `null` if this key does not support encoding.
  `String`
  `getFormat()`
  Returns the name of the primary encoding format of this key, or `null` if this key does not support encoding.

- ## Field Details

  - ### serialVersionUID

    @Deprecated static final long serialVersionUID
    Deprecated.
    A `serialVersionUID` field in an interface is ineffectual. Do not use; no replacement.
    The class fingerprint that is set to indicate serialization compatibility with a previous version of the class.
    See Also:
      - Constant Field Values